Program EdFolder;                 {$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}

Uses
  Dos, Crt, Console;

Type
  DirNameRec = record
    Fill00: array [$00..$03] of byte {C7 45 C1 53};
    GeoName: array [0..31] of char;
    Fill24: array [$24..$27] of byte;
    Code28: array [$28..$33] of byte {04};
    Code34: array [$34..$37] of byte {01};
    IconName: array [0..3] of char;
    IconMfgr: word;
    Creator: array [0..3] of char;
    CrMfgr: word;
    Notes: array [0..98] of char;
    FillA7: array [$A7..$C7] of byte;
    FIllC8: array [$C8..$FF] of byte {6A 1B 0D 1A}
    end {record DirNameRec};

Var
  Done: boolean;
  DirName: DirNameRec;
  F: file of DirNameRec;
  HasDirName: boolean;
  DefaultName: string[12];
  DirSt: string;
  SubDir, MaxSubDir: integer;

{######################################################################}

Procedure GetFolderName;

Var
  I: integer;
  FolderName: string[32];

Begin {GetFolderName}
Writeln;
{$I-} Reset (F) {$I+};
HasDirName := (IOResult = 0);
If HasDirName then with DirName do begin
  Read (F,DirName);
  Close (F);
  FolderName := '';
  I := 0;
  Repeat
    FolderName := FolderName + GeoName[I];
    Inc (I);
    until (I > 31) or (GeoName[I] = #0);
  Writeln ('[ 0] Edit GeoWorks name: "',FolderName,
    '" (icon: "',IconName,'",',IconMfgr,')')
  end {if HasDirName}
else
  Writeln ('[ 0] Create @DirName.000 file')
End {GetFolderName};

{######################################################################}

Function CountDirectories: integer;

Var
  DirEntry: SearchRec;
  Tally: integer;
  I: integer;

Begin
Tally := 0;
FindFirst ('*.*',directory,DirEntry);
While DosError = 0 do with DirEntry do begin
  If Attr = directory then
    If Name = '.' then begin
      DefaultName := '';
      I := length(DirSt);
      While DirSt[I] <> '\' do begin
        DefaultName := DirSt[I] + DefaultName;
        Dec (I)
        end {while DirSt[I] <> '\'}
      end {if Name = '.'}
    else begin
      Inc (Tally);
      Write ('[',Tally:2,'] ',Name,' ':15-length(Name))
      end;
  FindNext (DirEntry)
  end {while DosError = 0};
If Tally mod 4 <> 0 then Writeln;
Writeln;
CountDirectories := Tally
End;

{######################################################################}

Procedure ChangeToDir (Dir: integer);

Var
  DirEntry: SearchRec;

Begin {ChangeToDir}
FindFirst ('*.*',directory,DirEntry);
While DosError = 0 do with DirEntry do begin
  If (Attr = directory) and (Name <> '.') then Dec (Dir);
  If Dir = 0 then begin
    ChDir (DirEntry.Name);
    Exit
    end;
  FindNext (DirEntry)
  end {while DosError = 0};
Halt (3 {file not found})
End {ChangeToDir};
{######################################################################}

Procedure EditDirName;

Var
  NewName: string[32];
  NewMfgr: word;
  SaveAttr: word;

Begin {EditDirName}
With DirName do begin
  NewName := ReadString('New Folder name',32,[ ]);
  If not NullEntered then begin
    FillChar (GeoName,sizeof(GeoName),0);
    Move (NewName[1],GeoName,length(NewName))
    end {if not NullEntered};
  NewName := ReadString('New Icon name',4,[ ]);
  If not NullEntered then begin
    FillChar (IconName,sizeof(IconName),' ');
    Move (NewName[1],IconName,length(NewName))
    end {if not NullEntered};
  NewMfgr := ReadInteger('New Mfgr',0,65536,[display]);
  If not NullEntered then IconMfgr := NewMfgr
  end {with DirName};
GetFAttr (F,SaveAttr);
SetFAttr (F,(SaveAttr and not hidden));
Rewrite (F);
Write (F,DirName);
Close (F);
SetFAttr (F,SaveAttr)
End {EditDirName};

{######################################################################}

Procedure MakeDirName;

Begin {MakeDirName}
Rewrite (F);
FillChar (DirName,sizeof(DirName),0);
With DirName do begin
  Fill00[$00] := $C7; Fill00[$01] := $45;
  Fill00[$02] := $C1; Fill00[$03] := $53;
  Move (DefaultName[1],GeoName,length(DefaultName));
  Code28[$28] := $04;
  Code34[$34] := $01;
  IconName := 'FLDR';
  FillC8[$C8] := $6A; FillC8[$C9] := $1B;
  FillC8[$CA] := $0D; FillC8[$CB] := $1A
  end {with DirName};
Write (F,DirName);
Close (F);
HasDirName := true
End {MakeDirName};

{######################################################################}

Begin {EdFolder}
Assign (F,'@DirName.000');
Repeat
  ClrScr;
  GetDir (0,DirSt);
  Writeln ('Current folder ',DirSt);
  GetFolderName;
  DefaultName := '{Root}';
  MaxSubDir := CountDirectories;
  SubDir := ReadInteger ('Item to change (<ENTER> to quit)',0,MaxSubDir,
    [stoponspace]);
  Done := NullEntered;
  If not Done then begin
    If SubDir = 0 then
      If HasDirName then
        EditDirName
      else
        MakeDirName
    else {SubDir > 0}
      ChangeToDir (SubDir)
    end {if not Done}
  until done;
ClrScr
End {EdFolder}.
